1 # This file is sourced by init.sh, *before* its initialization.
3 # Copyright (C) 2010-2013 Free Software Foundation, Inc.
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 3 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see <http://www.gnu.org/licenses/>.
18 # This goes hand in hand with the "exec 9>&2;" in tests/Makefile.am's
19 # TESTS_ENVIRONMENT definition.
22 # Having an unsearchable directory in PATH causes execve to fail with EACCES
23 # when applied to an unresolvable program name, contrary to the desired ENOENT.
24 # Avoid the problem by rewriting PATH to exclude unsearchable directories.
25 # Also, if PATH lacks /sbin and/or /usr/sbin, append it/them.
28 # FIXME: remove double quotes around $IFS when all tests use init.sh.
29 # They constitute a work-around for a bug in FreeBSD 8.1's /bin/sh.
30 local saved_IFS="$IFS"
39 test -z "$d" && d1=. || d1=$d
40 if ls -d "$d1/." > /dev/null 2>&1; then
41 new_path="$new_path$colon$d"
46 for d in /sbin /usr/sbin ; do
49 *) new_path="$new_path:$d" ;;
60 test "$INT_MAX" || fatal_ "running getlimits"
65 getfacl --version < /dev/null > /dev/null 2>&1 \
66 && setfacl --version < /dev/null > /dev/null 2>&1 \
67 || skip_ "This test requires getfacl and setfacl."
69 id -u bin > /dev/null 2>&1 \
70 || skip_ "This test requires a local user named bin."
75 test $# = 1 || framework_failure_
76 df --local "$1" >/dev/null 2>&1
81 local mount_list_fail='cannot read table of mounted file systems'
82 df 2>&1 | grep -F "$mount_list_fail" >/dev/null &&
83 skip_ "$mount_list_fail"
90 skip_ "This test must be run on a local file system."
93 # Skip this test if we're not in SELinux "enforcing" mode.
94 require_selinux_enforcing_()
96 test "$(getenforce)" = Enforcing \
97 || skip_ "This test is useful only with SELinux in Enforcing mode."
100 require_openat_support_()
102 # Skip this test if your system has neither the openat-style functions
103 # nor /proc/self/fd support with which to emulate them.
104 test -z "$CONFIG_HEADER" \
105 && skip_ 'internal error: CONFIG_HEADER not defined'
108 grep '^#define HAVE_OPENAT' "$CONFIG_HEADER" > /dev/null && _skip=no
109 test -d /proc/self/fd && _skip=no
110 if test $_skip = yes; then
111 skip_ 'this system lacks openat support'
117 local ulimit_works=yes
118 # Expect to be able to exec a program in 10MiB of virtual memory,
119 # (10MiB is usually plenty, but valgrind-wrapped date requires 19000KiB,
120 # so allow more in that case)
121 # but not in 20KiB. I chose "date". It must not be a shell built-in
122 # function, so you can't use echo, printf, true, etc.
123 # Of course, in coreutils, I could use $top_builddir/src/true,
124 # but this should be able to work for other projects, too.
126 case $(printenv LD_PRELOAD) in */valgrind/*) vm=22000;; *) vm=10000;; esac
128 ( ulimit -v $vm; date ) > /dev/null 2>&1 || ulimit_works=no
129 ( ulimit -v 20; date ) > /dev/null 2>&1 && ulimit_works=no
131 test $ulimit_works = no \
132 && skip_ "this shell lacks ulimit support"
135 require_readable_root_()
137 test -r / || skip_ "/ is not readable"
140 # Skip the current test if strace is not available or doesn't work
141 # with the named syscall. Usage: require_strace_ unlink
144 test $# = 1 || framework_failure_
146 strace -V < /dev/null > /dev/null 2>&1 ||
147 skip_ 'no strace program'
149 strace -qe "$1" echo > /dev/null 2>&1 ||
150 skip_ 'strace -qe "'"$1"'" does not work'
152 # On some linux/sparc64 systems, strace works fine on 32-bit executables,
153 # but prints only one line of output for every 64-bit executable.
154 strace -o log-help ls --help >/dev/null || framework_failure_
155 n_lines_help=$(wc -l < log-help)
157 if test $n_lines_help = 0 || test $n_lines_help = 1; then
158 skip_ 'strace produces no more than one line of output'
162 # Skip the current test if valgrind doesn't work,
163 # which could happen if not installed,
164 # or hasn't support for the built architecture,
165 # or hasn't appropriate error suppressions installed etc.
168 valgrind --error-exitcode=1 true 2>/dev/null ||
169 skip_ "requires a working valgrind"
174 setfacl -m user::rwx . \
175 || skip_ "setfacl does not work on the current file system"
178 # Require a controlling input 'terminal'.
179 require_controlling_input_terminal_()
181 tty -s || have_input_tty=no
182 test -t 0 || have_input_tty=no
183 if test "$have_input_tty" = no; then
184 skip_ 'requires controlling input terminal
185 This test must have a controlling input "terminal", so it may not be
186 run via "batch", "at", or "ssh". On some systems, it may not even be
187 run in the background.'
195 case " $built_programs " in
197 *) echo "$i: not built" 1>&2; skip_=yes ;;
201 test $skip_ = yes && skip_ "required program(s) not built"
204 require_file_system_bytes_free_()
207 local expr=$(stat -f --printf "$req / %S <= %a" .)
208 $AWK "BEGIN{ exit !($expr) }" \
209 || skip_ "this test needs at least $req bytes of free space"
214 # Make sure id -u succeeds.
216 || { echo "$0: cannot run 'id -u'" 1>&2; return 1; }
218 # Make sure it gives valid output.
222 echo "$0: invalid output ('$my_uid') from 'id -u'" 1>&2
228 get_process_status_()
230 sed -n '/^State:[ ]*\([[:alpha:]]\).*/s//\1/p' /proc/$1/status
233 # Convert an ls-style permission string, like drwxr----x and -rw-r-x-wx
234 # to the equivalent chmod --mode (-m) argument, (=,u=rwx,g=r,o=x and
235 # =,u=rw,g=rx,o=wx). Ignore ACLs.
240 *) echo "$0: wrong number of arguments" 1>&2
241 echo "Usage: $0 ls-style-mode-string" 1>&2
246 [ld-][rwx-][rwx-][rwxsS-][rwx-][rwx-][rwxsS-][rwx-][rwx-][rwxtT-]) ;;
247 [ld-][rwx-][rwx-][rwxsS-][rwx-][rwx-][rwxsS-][rwx-][rwx-][rwxtT-][+.]) ;;
248 *) echo "$0: invalid mode string: $rwx" 1>&2; return;;
251 # Perform these conversions:
256 # The 'T' and 't' ones are only valid for 'other'.
257 s='s/S/@/;s/s/x@/;s/@/s/'
258 t='s/T/@/;s/t/x@/;s/@/t/'
260 u=$(echo $rwx|sed 's/^.\(...\).*/,u=\1/;s/-//g;s/^,u=$//;'$s)
261 g=$(echo $rwx|sed 's/^....\(...\).*/,g=\1/;s/-//g;s/^,g=$//;'$s)
262 o=$(echo $rwx|sed 's/^.......\(...\).*/,o=\1/;s/-//g;s/^,o=$//;'$s';'$t)
266 # Set the global variable stty_reversible_ to a space-separated list of the
267 # reversible settings from stty.c. stty_reversible_ also starts and ends
269 stty_reversible_init_()
271 # Pad start with one space for the first option to match in query function.
272 stty_reversible_=' '$(perl -lne '/^ *{"(.*?)",.*\bREV\b/ and print $1' \
273 "$abs_top_srcdir"/src/stty.c | tr '\n' ' ')
274 # Ensure that there are at least 62, i.e., so we're alerted if
275 # reformatting the source empties the list.
276 test 62 -le $(echo "$stty_reversible_"|wc -w) \
277 || framework_failure_ "too few reversible settings"
280 # Test whether $1 is one of stty's reversible options.
281 stty_reversible_query_()
283 case $stty_reversible_ in
285 framework_failure_ "stty_reversible_init_() not called?";;
296 root) skip_ must be run as root ;;
297 non-root) skip_ must be run as non-root ;;
304 # When in a chroot of an SELinux-enabled system, but with a mock-simulated
305 # SELinux-*disabled* system, recognize that SELinux is disabled system wide:
306 grep 'selinuxfs$' /proc/filesystems > /dev/null \
307 || skip_ "this system lacks SELinux support"
309 # Independent of whether SELinux is enabled system-wide,
310 # the current file system may lack SELinux support.
313 skip_ "this system (or maybe just" \
314 "the current file system) lacks SELinux support"
321 if test "$RUN_VERY_EXPENSIVE_TESTS" != yes; then
322 skip_ 'very expensive: disabled by default
323 This test is very expensive, so it is disabled by default.
324 To run it anyway, rerun make check with the RUN_VERY_EXPENSIVE_TESTS
325 environment variable set to yes. E.g.,
327 env RUN_VERY_EXPENSIVE_TESTS=yes make check
329 or use the shortcut target of the toplevel Makefile,
331 make check-very-expensive
338 if test "$RUN_EXPENSIVE_TESTS" != yes; then
339 skip_ 'expensive: disabled by default
340 This test is relatively expensive, so it is disabled by default.
341 To run it anyway, rerun make check with the RUN_EXPENSIVE_TESTS
342 environment variable set to yes. E.g.,
344 env RUN_EXPENSIVE_TESTS=yes make check
346 or use the shortcut target of the toplevel Makefile,
353 # Test whether we can run our just-built rm setuidgid-to-root,
354 # i.e., that $NON_ROOT_USERNAME has access to the build directory.
355 setuidgid_has_perm_()
358 setuidgid $NON_ROOT_USERNAME env PATH="$PATH" rm --version |
361 case ":$rm_version:" in
362 :$PACKAGE_VERSION:) ;;
369 uid_is_privileged_ || skip_ "must be run as root"
370 NON_ROOT_USERNAME=${NON_ROOT_USERNAME=nobody}
371 NON_ROOT_GROUP=${NON_ROOT_GROUP=$(id -g $NON_ROOT_USERNAME)}
373 # When the current test invokes setuidgid, call setuidgid_has_perm_
374 # to check for a common problem.
375 grep '^[ ]*setuidgid' "../$0" \
376 && { setuidgid_has_perm_ \
377 || skip_ "user $NON_ROOT_USERNAME lacks execute permissions"; }
380 skip_if_root_() { uid_is_privileged_ && skip_ "must be run as non-root"; }
382 # Set 'groups' to a space-separated list of at least two groups
383 # of which the user is a member.
384 require_membership_in_two_groups_()
386 test $# = 0 || framework_failure_
388 groups=${COREUTILS_GROUPS-$( (id -G || /usr/xpg4/bin/id -G) 2>/dev/null)}
391 *) skip_ 'requires membership in two groups
392 this test requires that you be a member of more than one group,
393 but running 'id -G'\'' either failed or found just one. If you really
394 are a member of at least two groups, then rerun this test with
395 COREUTILS_GROUPS set in your environment to the space-separated list
396 of group names or numbers. E.g.,
398 env COREUTILS_GROUPS='\''users cdrom'\'' make check
405 # Is /proc/$PID/status supported?
406 require_proc_pid_status_()
411 grep '^State:[ ]*[S]' /proc/$pid/status > /dev/null 2>&1 ||
412 skip_ "/proc/$pid/status: missing or 'different'"
416 # Return nonzero if the specified path is on a file system for
417 # which FIEMAP support exists. Note some file systems (like ext3 and btrfs)
418 # only support FIEMAP for files, not directories.
421 if ! python < /dev/null; then
422 warn_ 'fiemap_capable_: python missing: assuming not fiemap capable'
425 python "$abs_srcdir"/tests/fiemap-capable "$@"
428 # Skip the current test if "." lacks d_type support.
429 require_dirent_d_type_()
432 || skip_ python missing: assuming no d_type support
434 # Manually exclude xfs, since the test would mistakenly report
435 # that it has d_type support: d_type == DT_DIR for "." and "..",
436 # but DT_UNKNOWN for all other types.
437 df -x xfs . > /dev/null 2>&1 \
438 || skip_ requires d_type support
440 python "$abs_srcdir"/tests/d_type-check \
441 || skip_ requires d_type support
444 # Skip the current test if we lack Perl.
448 $PERL -e 'use warnings' > /dev/null 2>&1 \
449 || skip_ 'configure did not find a usable version of Perl'
452 # Does the current (working-dir) file system support sparse files?
453 require_sparse_support_()
455 test $# = 0 || framework_failure_
456 # Test whether we can create a sparse file.
457 # For example, on Darwin6.5 with a file system of type hfs, it's not possible.
458 # NTFS requires 128K before a hole appears in a sparse file.
460 dd bs=1 seek=128K of=$t < /dev/null 2> /dev/null
464 if test $kb_size -ge 128; then
465 skip_ 'this file system does not support sparse files'
469 # There are a myriad of ways to build shared libs,
470 # so we only consider running tests requiring shared libs,
471 # on platforms that support building them as follows.
472 require_gcc_shared_()
474 $CC -shared -fPIC -O2 -xc -o d.so -ldl - < /dev/null 2>&1 \
475 || skip_ '$CC -shared ... failed to build a shared lib'
480 test $# = 1 || framework_failure_
481 if ! mkfifo "$1"; then
482 # Make an exception of this case -- usually we interpret framework-creation
483 # failure as a test failure. However, in this case, when running on a SunOS
484 # system using a disk NFS mounted from OpenBSD, the above fails like this:
485 # mkfifo: cannot make fifo 'fifo-10558': Not owner
486 skip_ 'unable to create a fifo'
490 # Disable the current test if the working directory seems to have
491 # the setgid bit set.
494 setgid_tmpdir=setgid-$$
495 (umask 77; mkdir $setgid_tmpdir)
496 perms=$(stat --printf %A $setgid_tmpdir)
500 drwxr-xr-x);; # Windows98 + DJGPP 2.03
501 *) skip_ 'this directory has the setgid bit set';;
505 # Skip if files are created with a different group to the current user
506 # This can happen due to a setgid dir, or by some other mechanism on OS X:
507 # http://unix.stackexchange.com/q/63865
508 # http://bugs.gnu.org/14024#41
509 skip_if_nondefault_group_()
512 gen_ug=$(stat -c '%u:%g' grp.$$)
514 test "$gen_ug" = "$(id -ru):$(id -rg)" ||
515 skip_ 'Files are created with a different gid'
518 skip_if_mcstransd_is_running_()
520 test $# = 0 || framework_failure_
522 # When mcstransd is running, you'll see only the 3-component
523 # version of file-system context strings. Detect that,
524 # and if it's running, skip this test.
525 __ctx=$(stat --printf='%C\n' .) || framework_failure_
527 *:*:*:*) ;; # four components is ok
528 *) # anything else probably means mcstransd is running
529 skip_ "unexpected context '$__ctx'; turn off mcstransd" ;;
533 # Skip the current test if umask doesn't work as usual.
534 # This test should be run in the temporary directory that ends
535 # up being removed via the trap commands.
536 working_umask_or_skip_()
541 perms=$(ls -l file1 file2 | sed 's/ .*//' | uniq)
546 '*) skip_ 'your build directory has unusual umask semantics'
550 # Retry a function requiring a sufficient delay to _pass_
551 # using a truncated exponential backoff method.
552 # Example: retry_delay_ dd_reblock_1 .1 6
553 # This example will call the dd_reblock_1 function with
554 # an initial delay of .1 second and call it at most 6 times
555 # with a max delay of 3.2s (doubled each time), or a total of 6.3s
556 # Note ensure you do _not_ quote the parameter to GNU sleep in
557 # your function, as it may contain separate values that sleep
558 # needs to accumulate.
559 # Further function arguments will be forwarded to the test function.
568 local num_sleeps=$attempt
570 while test $attempt -le $max_n_tries; do
571 local delay=$($AWK -v n=$num_sleeps -v s="$init_delay" \
572 'BEGIN { print s * n }')
573 "$test_func" "$delay" "$@" && { time_fail=0; break; } || time_fail=1
574 attempt=$(expr $attempt + 1)
575 num_sleeps=$(expr $num_sleeps '*' 2)
577 test "$time_fail" = 0
580 # Call this with a list of programs under test immediately after
584 if test "$VERBOSE" = yes; then
592 # Are we running on GNU/Hurd?
595 test "$(uname)" = GNU \
596 || skip_ 'not running on GNU/Hurd'